import * as React from 'react';
import { Theme, WithStyles } from '@material-ui/core';
import { Address, DefaultProps, LabelFieldProps, TextFieldProps } from '../index';
declare type ComponentProps = {
    name?: string;
    value?: Address;
    usePlaceholder?: boolean;
    addressError?: {
        street?: boolean;
        streetNumber?: boolean;
        postalCode?: boolean;
    };
    addressHelper?: {
        street?: string;
        streetNumber?: string;
        postalCode?: string;
    };
    LabelFieldProps?: Pick<LabelFieldProps, 'variant' | 'withBoldTitle'>;
    onChange?(value: Address, fields?: string[]): void;
    onClear?(event: React.ChangeEvent<HTMLInputElement>, fields?: string[]): void;
};
export declare type Props = ComponentProps & Pick<TextFieldProps, 'mode' | 'label' | 'error' | 'helperText' | 'className' | 'onClear' | 'variant'> & WithStyles<typeof styles>;
declare const styles: (theme: Theme) => Record<"input" | "root" | "inputContainer", import("@material-ui/core/styles/withStyles").CSSProperties | import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}> | ((props: {}) => import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}>)>;
declare const _default: React.ComponentType<Pick<Pick<Props, "error" | "label" | "name" | "className" | "classes" | "onChange" | "variant" | "LabelFieldProps" | "onClear" | "helperText" | "usePlaceholder" | "addressHelper"> & Partial<Pick<Props, "value" | "mode" | "addressError">> & Partial<Pick<DefaultProps<Props, "value" | "mode" | "addressError">, never>>, "error" | "label" | "name" | "className" | "onChange" | "variant" | "value" | "mode" | "LabelFieldProps" | "onClear" | "helperText" | "addressError" | "usePlaceholder" | "addressHelper"> & import("@material-ui/core").StyledComponentProps<"input" | "root" | "inputContainer">>;
export default _default;
