var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import * as classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core';
import Typography from '@material-ui/core/Typography';
import FormHelperText from '@material-ui/core/FormHelperText';
import { LabelField, TextField, } from '../index';
import { LocationUtils } from '../utils';
import Strings from './AddressForm.strings';
var styles = function (theme) {
    var _a;
    return createStyles({
        root: {
            display: 'flex',
            flexDirection: 'column',
        },
        inputContainer: (_a = {
                width: '100%',
                display: 'flex',
                flexDirection: 'row',
                '& $input:not(:last-of-type)': {
                    marginRight: theme.spacing(2),
                }
            },
            _a[theme.breakpoints.down(theme.breakpoints.values.sm)] = {
                flexDirection: 'column',
                alignItems: 'stretch',
                '& $input:not(:last-of-type)': {
                    marginRight: 0,
                    marginBottom: theme.spacing(2),
                },
            },
            _a),
        input: {
            flex: 1,
            '&:first-of-type': {
                flex: 5,
            },
        },
    });
};
var AddressForm = /** @class */ (function (_super) {
    __extends(AddressForm, _super);
    function AddressForm() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOnChange = function (event) {
            var _a;
            var _b = _this.props, value = _b.value, onChange = _b.onChange;
            if (!onChange) {
                return;
            }
            var field = event.target.name;
            var v = event.target.value;
            onChange(__assign(__assign({}, value), (_a = {}, _a[field] = v, _a)), [field]);
        };
        _this.handleOnClear = function (event) {
            var _a = _this.props, value = _a.value, onChange = _a.onChange, onClear = _a.onClear;
            var field = event.target.name;
            var v = __assign({}, value);
            delete v[field];
            if (Object.keys(v).length === 0 && onClear) {
                onClear(event, [field]);
            }
            else if (onChange) {
                onChange(v, [field]);
            }
        };
        return _this;
    }
    AddressForm.prototype.render = function () {
        var _a = this.props, label = _a.label, value = _a.value, mode = _a.mode, usePlaceholder = _a.usePlaceholder, helperText = _a.helperText, error = _a.error, variant = _a.variant, addressError = _a.addressError, addressHelper = _a.addressHelper, LabelFieldProps = _a.LabelFieldProps, className = _a.className, classes = _a.classes;
        if (mode === 'label') {
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: label, value: LocationUtils.addressToString(value), className: className })));
        }
        var helpers = addressHelper || {};
        return (React.createElement("div", { className: classNames(classes.root, className) },
            label && React.createElement(Typography, { gutterBottom: true }, label),
            React.createElement("div", { className: classes.inputContainer },
                React.createElement(TextField, { name: "street", placeholder: usePlaceholder ? Strings.street : undefined, label: !usePlaceholder ? Strings.street : undefined, helperText: helpers.street, value: value.street || '', error: error || addressError.street, variant: variant, onChange: this.handleOnChange, onClear: this.handleOnClear, className: classes.input }),
                React.createElement(TextField, { name: "streetNumber", placeholder: usePlaceholder ? Strings.streetNumber : undefined, label: !usePlaceholder ? Strings.streetNumber : undefined, helperText: helpers.streetNumber, value: value.streetNumber || '', error: error || addressError.streetNumber, variant: variant, onChange: this.handleOnChange, onClear: this.handleOnClear, className: classes.input }),
                React.createElement(TextField, { name: "postalCode", placeholder: usePlaceholder ? Strings.postalCode : undefined, label: !usePlaceholder ? Strings.postalCode : undefined, helperText: helpers.postalCode, value: value.postalCode || '', error: error || addressError.postalCode, variant: variant, onChange: this.handleOnChange, onClear: this.handleOnClear, className: classes.input })),
            helperText && (React.createElement(FormHelperText, { error: error ||
                    addressError.street ||
                    addressError.streetNumber ||
                    addressError.postalCode }, helperText))));
    };
    AddressForm.defaultProps = {
        mode: 'input',
        value: {},
        addressError: {},
    };
    return AddressForm;
}(React.Component));
export default withStyles(styles)(AddressForm);
//# sourceMappingURL=AddressForm.js.map