var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { createStyles, withStyles } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';
import { Dialog } from '../index';
import Strings from './AlertDialog.strings';
var styles = function (theme) { return createStyles({}); };
var AlertDialog = /** @class */ (function (_super) {
    __extends(AlertDialog, _super);
    function AlertDialog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleCloseButtonClick = function () {
            if (_this.props.onClose) {
                _this.props.onClose({}, 'escapeKeyDown');
            }
        };
        return _this;
    }
    AlertDialog.prototype.render = function () {
        var _a = this.props, message = _a.message, actionText = _a.actionText, children = _a.children, restProps = __rest(_a, ["message", "actionText", "children"]);
        return (React.createElement(Dialog, __assign({}, restProps, { actions: [
                {
                    primary: true,
                    handler: this.handleCloseButtonClick,
                    text: actionText,
                },
            ] }),
            React.createElement(Typography, null, message)));
    };
    AlertDialog.defaultProps = {
        actionText: Strings.ok,
    };
    return AlertDialog;
}(React.Component));
export default withStyles(styles)(AlertDialog);
//# sourceMappingURL=AlertDialog.js.map