var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { debounce, cloneDeep, get } from 'lodash';
import * as Autosuggest from 'react-autosuggest';
import classNames from 'classnames';
import { withStyles, createStyles } from '@material-ui/core/styles';
import MenuItem from '@material-ui/core/MenuItem';
import Paper from '@material-ui/core/Paper';
import CircularProgress from '@material-ui/core/CircularProgress';
import LinearProgress from '@material-ui/core/LinearProgress';
import { TextField } from '../index';
var styles = function (theme) {
    var _a;
    return createStyles({
        textFieldContainer: {
            position: 'relative',
            width: '100%',
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'center',
        },
        textField: {},
        icon: {
            height: 18,
            width: 18,
            marginRight: theme.spacing(1),
        },
        themeContainer: {
            position: 'relative',
        },
        themeSuggestionsContainer: {},
        themeSuggestion: {},
        themeSuggestionsList: {
            margin: 0,
            padding: 0,
            listStyleType: 'none',
        },
        suggestionsContainer: {
            position: 'absolute',
            zIndex: 1,
            left: 0,
            right: 0,
        },
        suggestionsContainerWithIcon: {
            position: 'absolute',
            zIndex: 1,
            left: 24,
            right: 0,
        },
        suggestion: (_a = {
                overflowX: 'scroll'
            },
            _a[theme.breakpoints.down('xs')] = {
                fontSize: '.8rem',
            },
            _a),
        linearProgress: {
            position: 'absolute',
            bottom: 0,
            left: 0,
            right: 0,
            height: 2,
        },
    });
};
var AutocompleteTextField = /** @class */ (function (_super) {
    __extends(AutocompleteTextField, _super);
    function AutocompleteTextField(props) {
        var _this = _super.call(this, props) || this;
        _this.fetchSuggestions = function (inputValue) { return __awaiter(_this, void 0, void 0, function () {
            var searchParams, suggestions, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.canFetchSuggestions(inputValue)) {
                            return [2 /*return*/];
                        }
                        this.setState({
                            loading: true,
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        searchParams = this.props.withSearchParams ? this.props.searchParams : inputValue;
                        return [4 /*yield*/, this.props.fetchSuggestions(searchParams)];
                    case 2:
                        suggestions = _a.sent();
                        this.setState({
                            suggestions: suggestions,
                        });
                        return [3 /*break*/, 5];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1);
                        return [3 /*break*/, 5];
                    case 4:
                        this.setState({
                            loading: false,
                        });
                        return [7 /*endfinally*/];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        _this.canFetchSuggestions = function (inputValue) {
            if (!_this.props.withSearchParams) {
                return inputValue.trim().length !== 0;
            }
            var searchParamsFields = _this.props.searchParamsFields || [];
            return searchParamsFields.every(function (f) { return get(_this.props.searchParams, f) !== undefined; });
        };
        _this.filterSuggestions = function (value) {
            var _a = _this.props, suggestions = _a.suggestions, suggestionLabelField = _a.suggestionLabelField;
            var inputValue = value.trim().toLowerCase();
            var inputLength = inputValue.length;
            var currentSuggestions = inputLength === 0
                ? []
                : suggestions.filter(function (s) {
                    return s[suggestionLabelField].toLowerCase().includes(inputValue.toLowerCase());
                });
            _this.setState({
                suggestions: currentSuggestions,
            });
        };
        // Teach Autosuggest how to calculate suggestions for any given input value.
        _this.getSuggestions = function (value) { return __awaiter(_this, void 0, void 0, function () {
            var fetchSuggestions;
            return __generator(this, function (_a) {
                fetchSuggestions = this.props.fetchSuggestions;
                if (fetchSuggestions) {
                    this.debouncedFetchSuggestions(value);
                }
                else {
                    this.filterSuggestions(value);
                }
                return [2 /*return*/];
            });
        }); };
        _this.handleOnChange = function (event, value) {
            var onChange = _this.props.onChange;
            if (value.method === 'type' && onChange) {
                onChange(event);
            }
        };
        // When suggestion is clicked, Autosuggest needs to populate the input
        // based on the clicked suggestion. Teach Autosuggest how to calculate the
        // input value for every given suggestion.
        _this.getSuggestionValue = function (suggestion) { return suggestion[_this.props.suggestionLabelField]; };
        // Autosuggest will call this function every time you need to update suggestions.
        // You already implemented this logic above, so just use it.
        _this.handleOnSuggestionsFetchRequested = function (params) {
            if (params.reason !== 'input-focused') {
                _this.getSuggestions(params.value);
            }
        };
        // Autosuggest will call this function every time you need to clear suggestions.
        _this.handleOnSuggestionsClearRequested = function () {
            _this.setState({
                suggestions: [],
            });
        };
        _this.handleOnSuggestionSelected = function (event, value) {
            if (_this.props.onSuggestionSelected) {
                _this.props.onSuggestionSelected(value.suggestion, _this.props.name);
            }
        };
        _this.handleOnBlur = function (event, _a) {
            var highlightedSuggestion = _a.highlightedSuggestion;
            // Reset the value
            if (!_this.props.withFreeInput && _this.props.onChange && !highlightedSuggestion) {
                event.target.value = '';
                _this.props.onChange(event);
            }
        };
        /* Renders */
        _this.renderInput = function (inputProps) {
            var mode = _this.props.mode;
            var classes = inputProps.classes, ref = inputProps.ref, startAdornment = inputProps.startAdornment, variant = inputProps.variant, other = __rest(inputProps, ["classes", "ref", "startAdornment", "variant"]);
            var Icon = _this.props.icon;
            var loadingVariant = variant === 'filled' ? 'bar' : _this.props.loadingVariant;
            var icon = Icon !== undefined && React.createElement(Icon, { className: classes.icon });
            var loadingBar = _this.state.loading && loadingVariant === 'bar' && (React.createElement(LinearProgress, { color: "secondary", className: classes.linearProgress }));
            var loadingIcon = _this.state.loading && loadingVariant === 'icon' && (React.createElement(CircularProgress, { size: 18, className: classes.icon }));
            return (React.createElement("div", { className: classes.textFieldContainer },
                React.createElement(TextField, __assign({}, other, { mode: mode, disabled: _this.props.disabled, error: _this.props.error, helperText: _this.props.helperText, variant: variant, fullWidth: true, autoComplete: "no", startAdornment: icon, endAdornment: loadingIcon, className: classes.textField })),
                loadingBar));
        };
        _this.renderSuggestionsContainer = function (options) {
            var containerProps = options.containerProps, children = options.children;
            return (React.createElement(Paper, __assign({}, containerProps, { square: true, className: _this.props.classes.suggestionsContainer }), children));
        };
        _this.renderSuggestion = function (suggestion) {
            var label = get(suggestion, _this.props.suggestionLabelField);
            if (label === undefined) {
                console.warn('Suggestion has no field with name: ' + _this.props.suggestionLabelField);
            }
            return (React.createElement(MenuItem, { component: "div", className: _this.props.classes.suggestion }, label));
        };
        _this.state = {
            suggestions: cloneDeep(props.suggestions || []),
            loading: false,
        };
        if (props.fetchSuggestions) {
            _this.debouncedFetchSuggestions = debounce(_this.fetchSuggestions, 200);
        }
        return _this;
    }
    AutocompleteTextField.prototype.render = function () {
        var _a = this.props, classes = _a.classes, suggestionLabelField = _a.suggestionLabelField, withFreeInput = _a.withFreeInput, withSearchParams = _a.withSearchParams, fetchSuggestions = _a.fetchSuggestions, loadingVariant = _a.loadingVariant, onSuggestionSelected = _a.onSuggestionSelected, value = _a.value, searchParams = _a.searchParams, searchParamsFields = _a.searchParamsFields, required = _a.required, size = _a.size, className = _a.className, restProps = __rest(_a, ["classes", "suggestionLabelField", "withFreeInput", "withSearchParams", "fetchSuggestions", "loadingVariant", "onSuggestionSelected", "value", "searchParams", "searchParamsFields", "required", "size", "className"]);
        var suggestions = this.state.suggestions;
        // Autosuggest will pass through all these props to the input.
        var inputProps = __assign(__assign({}, restProps), { classes: classes, defaultValue: undefined, value: value || '', onChange: this.handleOnChange, onBlur: this.handleOnBlur });
        return (React.createElement(Autosuggest, { suggestions: suggestions, renderInputComponent: this.renderInput, renderSuggestion: this.renderSuggestion, renderSuggestionsContainer: this.renderSuggestionsContainer, onSuggestionsFetchRequested: this.handleOnSuggestionsFetchRequested, onSuggestionsClearRequested: this.handleOnSuggestionsClearRequested, onSuggestionSelected: this.handleOnSuggestionSelected, getSuggestionValue: this.getSuggestionValue, focusInputOnSuggestionClick: false, inputProps: inputProps, theme: {
                container: classNames(classes.themeContainer, className),
                suggestionsContainer: classes.suggestionsContainer,
                suggestionsContainerOpen: classes.themeSuggestionsContainer,
                suggestionsList: classes.themeSuggestionsList,
                suggestion: classes.themeSuggestion,
            } }));
    };
    AutocompleteTextField.defaultProps = {
        required: false,
        error: false,
        disabled: false,
        withFreeInput: true,
        withSearchParams: false,
        suggestions: [],
        loadingVariant: 'icon',
        suggestionLabelField: 'label',
    };
    return AutocompleteTextField;
}(React.Component));
export default withStyles(styles)(AutocompleteTextField);
//# sourceMappingURL=AutocompleteTextField.js.map