var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { default as MaterialButton, } from '@material-ui/core/Button';
import CircularProgress from '@material-ui/core/CircularProgress';
import { default as MaterialIconButton, } from '@material-ui/core/IconButton';
var styles = function (theme) {
    return createStyles({
        root: {
            position: 'relative',
        },
        withSubtext: {
            padding: "calc(6px + 0.55rem) " + theme.spacing(1) + "px",
        },
        disabled: {
            backgroundColor: 'rgba(0, 0, 0, 0.1) !important',
        },
        loading: {
            '& > span:first-child': {
                color: 'transparent',
            },
        },
        loadingView: {
            position: 'absolute',
            top: 'calc(50% - 9px)',
            left: 'calc(50% - 9px)',
            zIndex: 1,
        },
        label: {
            display: 'block',
            lineHeight: 1.2,
        },
        subtext: {
            textTransform: 'none',
            fontSize: '0.6rem',
            opacity: .8,
        },
    });
};
var Button = /** @class */ (function (_super) {
    __extends(Button, _super);
    function Button(props) {
        return _super.call(this, props) || this;
    }
    Button.prototype.render = function () {
        var _a, _b, _c;
        var _d = this.props, subtext = _d.subtext, loading = _d.loading, disabled = _d.disabled, children = _d.children, color = _d.color, className = _d.className, classes = _d.classes, version = _d.version, variant = _d.variant, restProps = __rest(_d, ["subtext", "loading", "disabled", "children", "color", "className", "classes", "version", "variant"]);
        var loadingColor = color;
        if (loadingColor === 'default') {
            loadingColor = 'inherit';
        }
        if (version === 'icon') {
            return (React.createElement(MaterialIconButton, __assign({}, restProps, { color: color, disabled: disabled || loading, className: classNames(classes.root, className), classes: {
                    disabled: classNames((_a = {},
                        _a[classes.disabled] = loading,
                        _a[classes.loading] = loading,
                        _a)),
                } }),
                children,
                loading && (React.createElement(CircularProgress, { color: loadingColor, size: 18, className: classes.loadingView }))));
        }
        return (React.createElement(MaterialButton, __assign({}, restProps, { color: color, variant: variant, disabled: disabled || loading, className: className, classes: {
                root: classNames(classes.root, (_b = {}, _b[classes.withSubtext] = subtext !== undefined, _b)),
                label: subtext ? classes.label : undefined,
                disabled: classNames(classes.disabled, (_c = {},
                    _c[classes.loading] = loading,
                    _c)),
            } }),
            children,
            subtext && (React.createElement(React.Fragment, null,
                React.createElement("br", null),
                React.createElement("span", { className: classes.subtext }, subtext))),
            loading && (React.createElement(CircularProgress, { color: loadingColor, size: 18, className: classes.loadingView }))));
    };
    Button.defaultProps = {
        loading: false,
        version: 'default',
    };
    return Button;
}(React.Component));
export default withStyles(styles)(Button);
//# sourceMappingURL=Button.js.map