var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import * as classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { default as MaterialCheckbox } from '@material-ui/core/Checkbox';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import FormHelperText from '@material-ui/core/FormHelperText';
import { LabelField } from '../index';
import Strings from './Checkbox.strings';
var styles = function (theme) {
    return createStyles({
        root: {},
        checkbox: {},
        label: {
            marginRight: 0,
        },
        error: {
            color: theme.palette.error.main,
        },
        helper: {
            marginTop: theme.spacing(1),
        },
    });
};
var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Checkbox.prototype.render = function () {
        var _a;
        var _b = this.props, mode = _b.mode, placeholder = _b.placeholder, helperText = _b.helperText, checked = _b.checked, error = _b.error, LabelFieldProps = _b.LabelFieldProps, classes = _b.classes, className = _b.className, restProps = __rest(_b, ["mode", "placeholder", "helperText", "checked", "error", "LabelFieldProps", "classes", "className"]);
        if (mode === 'label') {
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: placeholder, value: checked ? Strings.checked : Strings.notChecked, className: className })));
        }
        return (React.createElement("div", { className: classNames(classes.root, className) },
            React.createElement(FormControlLabel, { label: placeholder, control: React.createElement(MaterialCheckbox, __assign({}, restProps, { checked: checked || false, className: classes.checkbox })), classes: { root: classes.label }, className: classNames((_a = {}, _a[classes.error] = error, _a)) }),
            helperText && (React.createElement(FormHelperText, { error: error, className: classes.helper }, helperText))));
    };
    return Checkbox;
}(React.Component));
export default withStyles(styles)(Checkbox);
//# sourceMappingURL=Checkbox.js.map