var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { Typography } from '@material-ui/core';
import { Dialog } from '../index';
import Strings from './ConfirmDialog.strings';
var ConfirmDialog = /** @class */ (function (_super) {
    __extends(ConfirmDialog, _super);
    function ConfirmDialog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handlePositiveButtonClick = function () {
            if (_this.props.onPositiveButtonClick) {
                _this.props.onPositiveButtonClick();
            }
            if (_this.props.onClose) {
                _this.props.onClose({}, 'escapeKeyDown');
            }
        };
        _this.handleNegativeButtonClick = function () {
            if (_this.props.onNegativeButtonClick) {
                _this.props.onNegativeButtonClick();
            }
            if (_this.props.onClose) {
                _this.props.onClose({}, 'escapeKeyDown');
            }
        };
        return _this;
    }
    ConfirmDialog.prototype.render = function () {
        var _a = this.props, message = _a.message, positiveActionText = _a.positiveActionText, negativeActionText = _a.negativeActionText, onPositiveButtonClick = _a.onPositiveButtonClick, onNegativeButtonClick = _a.onNegativeButtonClick, restProps = __rest(_a, ["message", "positiveActionText", "negativeActionText", "onPositiveButtonClick", "onNegativeButtonClick"]);
        return (React.createElement(Dialog, __assign({}, restProps, { actions: [
                {
                    text: negativeActionText,
                    handler: this.handleNegativeButtonClick,
                },
                {
                    text: positiveActionText,
                    color: 'primary',
                    handler: this.handlePositiveButtonClick,
                },
            ] }),
            React.createElement(Typography, null, message)));
    };
    ConfirmDialog.defaultProps = {
        positiveActionText: Strings.positiveButton,
        negativeActionText: Strings.negativeButton,
    };
    return ConfirmDialog;
}(React.Component));
export default ConfirmDialog;
//# sourceMappingURL=ConfirmDialog.js.map