import * as React from 'react';
import { Theme, WithStyles } from '@material-ui/core/styles';
import { DefaultProps, InputFieldMode, LabelFieldProps } from '../index';
declare type ComponentProps = {
    label: string;
    value: number;
    min?: number;
    max?: number;
    disabled?: boolean;
    error?: boolean;
    mode?: InputFieldMode;
    color?: 'primary' | 'secondary';
    variant?: 'row' | 'column';
    LabelFieldProps?: Pick<LabelFieldProps, 'variant' | 'withBoldTitle'>;
    className?: string;
    onChange?(v: number, isPlus: boolean): void;
};
export declare type Props = ComponentProps & WithStyles<typeof styles>;
declare const styles: (theme: Theme) => Record<"label" | "root" | "value" | "rowVariant" | "columnVariant" | "buttonsContainer", import("@material-ui/core/styles/withStyles").CSSProperties | import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}> | ((props: {}) => import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}>)>;
declare const _default: React.ComponentType<Pick<Pick<Props, "max" | "label" | "className" | "classes" | "onChange" | "value" | "min" | "LabelFieldProps"> & Partial<Pick<Props, "disabled" | "error" | "color" | "variant" | "mode">> & Partial<Pick<DefaultProps<Props, "disabled" | "error" | "color" | "variant" | "mode">, never>>, "max" | "disabled" | "error" | "label" | "color" | "className" | "onChange" | "variant" | "value" | "min" | "mode" | "LabelFieldProps"> & import("@material-ui/core/styles").StyledComponentProps<"label" | "root" | "value" | "rowVariant" | "columnVariant" | "buttonsContainer">>;
export default _default;
