var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';
import IconButton from '@material-ui/core/IconButton';
import { Remove as MinusIcon, Add as PlusIcon } from '@material-ui/icons';
import { LabelField } from '../index';
var styles = function (theme) {
    return createStyles({
        root: {
            width: 'fit-content',
            display: 'flex',
        },
        rowVariant: {
            flexDirection: 'row',
            alignItems: 'center',
            '& > $label': {
                marginRight: theme.spacing(2),
            },
        },
        columnVariant: {
            flexDirection: 'column',
        },
        label: {},
        buttonsContainer: {
            width: 'fit-content',
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'center',
            justifyContent: 'space-around',
        },
        value: {
            minWidth: 20,
            margin: theme.spacing(0, 1),
            textAlign: 'center',
        },
    });
};
var Counter = /** @class */ (function (_super) {
    __extends(Counter, _super);
    function Counter(props) {
        var _this = _super.call(this, props) || this;
        _this.handleOnButtonClick = function (isPlus) { return function () {
            var _a = _this.props, value = _a.value, min = _a.min, max = _a.max, onChange = _a.onChange;
            if (!onChange) {
                return;
            }
            // Min value reached
            if (min !== undefined && !isPlus && value === min) {
                return;
            }
            // Max value reached
            if (max !== undefined && isPlus && value === max) {
                return;
            }
            onChange(_this.props.value + (isPlus ? 1 : -1), isPlus);
        }; };
        return _this;
    }
    Counter.prototype.render = function () {
        var _a = this.props, label = _a.label, value = _a.value, color = _a.color, disabled = _a.disabled, error = _a.error, mode = _a.mode, variant = _a.variant, LabelFieldProps = _a.LabelFieldProps, classes = _a.classes, className = _a.className;
        if (mode === 'label') {
            return React.createElement(LabelField, __assign({}, LabelFieldProps, { label: label, value: value, className: className }));
        }
        return (React.createElement("div", { className: classNames(classes.root, variant === 'row' ? classes.rowVariant : classes.columnVariant, className) },
            React.createElement(Typography, { color: error ? 'error' : 'initial', gutterBottom: variant === 'column', className: classes.label }, label),
            React.createElement("div", { className: classes.buttonsContainer },
                React.createElement(IconButton, { size: "small", color: color, disabled: disabled, onClick: this.handleOnButtonClick(false) },
                    React.createElement(MinusIcon, { fontSize: "inherit" })),
                React.createElement(Typography, { className: classes.value }, value),
                React.createElement(IconButton, { size: "small", color: color, disabled: disabled, onClick: this.handleOnButtonClick(true) },
                    React.createElement(PlusIcon, { fontSize: "inherit" })))));
    };
    Counter.defaultProps = {
        color: 'secondary',
        mode: 'input',
        variant: 'row',
        disabled: false,
        error: false,
    };
    return Counter;
}(React.Component));
export default withStyles(styles)(Counter);
//# sourceMappingURL=Counter.js.map