var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as React from 'react';
import { withStyles, createStyles } from '@material-ui/core/styles';
import { CardNumberElement, CardExpiryElement, CardCVCElement, Elements, injectStripe, } from 'react-stripe-elements';
import Strings from './CreditCardForm.strings';
import CloseIcon from '@material-ui/icons/Close';
import { PaymentSourceType } from './index';
import { Typography } from '@material-ui/core';
import Button from '../Button';
import IconButton from '@material-ui/core/IconButton';
import AlertDialog from '../AlertDialog';
import LoadingView from '../LoadingView';
import PoweredByStripeLogo from './PoweredByStripeLogo';
var styles = function (theme) {
    var _a, _b, _c;
    return createStyles({
        root: {
            border: '1px solid #ccc',
            borderRadius: 3,
            backgroundColor: '#f3f3f3',
            padding: theme.spacing(2),
        },
        titleContainer: {
            display: 'flex',
            flexDirection: 'row',
            justifyContent: 'space-between',
            alignItems: 'center',
            marginBottom: theme.spacing(2),
        },
        label: {
            color: '#6b7c93',
            fontWeight: 300,
            letterSpacing: theme.spacing(0.025),
        },
        input: {
            display: 'block',
            margin: '10px 0 20px 0',
            padding: '10px 14px',
            fontSize: theme.spacing(1),
            fontFamily: '"Source Code Pro" monospace',
            boxShadow: 'rgba(50, 50, 93, 0.14902) 0px 1px 3px, rgba(0, 0, 0, 0.0196078) 0px 1px 0px',
            border: 0,
            outline: 0,
            borderRadius: 4,
            background: 'white',
        },
        actionsContainer: (_a = {
                display: 'flex',
                flexDirection: 'row',
                justifyContent: 'space-between',
                alignItems: 'center'
            },
            _a[theme.breakpoints.down(550)] = {
                flexDirection: 'column-reverse',
                alignItems: 'center',
            },
            _a),
        stripeLogo: (_b = {
                display: 'flex',
                justifyContent: 'center',
                maxWidth: 200
            },
            _b[theme.breakpoints.down(550)] = {
                marginTop: theme.spacing(2),
            },
            _b),
        saveButton: (_c = {},
            _c[theme.breakpoints.down(550)] = {
                alignSelf: 'normal',
            },
            _c),
    });
};
var createOptions = function () {
    return {
        style: {
            base: {
                color: '#424770',
                letterSpacing: '0.025em',
                fontFamily: 'Source Code Pro, monospace',
                '::placeholder': {
                    color: '#aab7c4',
                },
            },
            invalid: {
                color: '#9e2146',
            },
        },
    };
};
var Form = /** @class */ (function (_super) {
    __extends(Form, _super);
    function Form(props) {
        var _this = _super.call(this, props) || this;
        _this.createSource = function () { return __awaiter(_this, void 0, void 0, function () {
            var payload, paymentSource;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.props.stripe) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.props.stripe.createSource({ type: 'card' })];
                    case 1:
                        payload = _a.sent();
                        if (payload.error) {
                            this.props.onCardError(payload.error);
                        }
                        else if (payload.source && payload.source.card) {
                            paymentSource = {
                                id: payload.source.id,
                                type: PaymentSourceType.CreditCard,
                                card: {
                                    brand: payload.source.card.brand,
                                    last4: payload.source.card.last4,
                                    expireMonth: payload.source.card.exp_month,
                                    expireYear: payload.source.card.exp_year,
                                },
                            };
                            this.props.onCardSaved(paymentSource);
                        }
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        }); };
        _this.handleSubmit = function (event) {
            event.preventDefault();
            _this.props.onSaveClick();
            _this.createSource();
        };
        _this.state = {
            shouldSaveCard: false,
        };
        return _this;
    }
    Form.prototype.render = function () {
        var _a = this.props, classes = _a.classes, texts = _a.texts, PayButtonProps = _a.PayButtonProps;
        return (React.createElement("form", { onSubmit: this.handleSubmit },
            React.createElement("label", { className: classes.label },
                React.createElement(Typography, null, texts.cardNumber),
                React.createElement(CardNumberElement, __assign({ className: classes.input }, createOptions()))),
            React.createElement("label", { className: classes.label },
                React.createElement(Typography, null, texts.expirationDate),
                React.createElement(CardExpiryElement, __assign({ className: classes.input }, createOptions()))),
            React.createElement("label", { className: classes.label },
                React.createElement(Typography, null, texts.cvc),
                React.createElement(CardCVCElement, __assign({ className: classes.input }, createOptions()))),
            React.createElement("div", { className: classes.actionsContainer },
                React.createElement("a", { href: "https://stripe.com", target: "_blank", className: classes.stripeLogo },
                    React.createElement(PoweredByStripeLogo, null)),
                React.createElement(Button, __assign({ className: classes.saveButton, variant: "contained", color: "primary", type: "submit" }, PayButtonProps), texts.save))));
    };
    return Form;
}(React.Component));
var WrappedForm = injectStripe(Form);
var CreditCardForm = /** @class */ (function (_super) {
    __extends(CreditCardForm, _super);
    function CreditCardForm(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSaveClick = function () {
            _this.setState({ loading: true });
        };
        _this.handleCardError = function (err) {
            _this.setState({
                loading: false,
                alertOpen: true,
                alertMessage: err && err.message ? err.message : Strings.unexpectedError,
            });
        };
        _this.handleCardSaved = function (paymentSource) {
            _this.setState({ loading: false }, function () {
                _this.props.onCardSaved(paymentSource);
            });
        };
        _this.handleAlertClose = function () {
            _this.setState({ alertOpen: false, alertMessage: undefined });
        };
        _this.handleFormClose = function () {
            if (_this.props.onClose) {
                _this.props.onClose();
            }
        };
        _this.state = {
            loading: false,
            alertOpen: false,
        };
        return _this;
    }
    CreditCardForm.prototype.render = function () {
        var _a = this.props, classes = _a.classes, texts = _a.texts, disableCloseButton = _a.disableCloseButton, PayButtonProps = _a.PayButtonProps;
        var loading = this.state.loading;
        return (React.createElement("div", { className: classes.root },
            React.createElement("div", { className: classes.titleContainer },
                React.createElement(Typography, { variant: "h5" }, texts.title),
                !disableCloseButton && (React.createElement(IconButton, { onClick: this.handleFormClose },
                    React.createElement(CloseIcon, null)))),
            React.createElement(Elements, null,
                React.createElement(WrappedForm, { texts: texts, classes: classes, onSaveClick: this.handleSaveClick, onCardSaved: this.handleCardSaved, onCardError: this.handleCardError, PayButtonProps: PayButtonProps })),
            React.createElement(AlertDialog, { open: this.state.alertOpen, title: Strings.alert.title, message: this.state.alertMessage, actionText: Strings.alert.button, onClose: this.handleAlertClose }),
            React.createElement(LoadingView, { visible: loading })));
    };
    CreditCardForm.defaultProps = {
        texts: {
            title: Strings.formTitle,
            cardNumber: Strings.cardNumber,
            expirationDate: Strings.expirationDate,
            cvc: Strings.cvc,
            postalCode: Strings.postalCode,
            save: Strings.save,
        },
    };
    return CreditCardForm;
}(React.Component));
export default withStyles(styles)(CreditCardForm);
//# sourceMappingURL=CreditCardForm.js.map