var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import * as moment from 'moment';
import MaskedInput from 'react-text-mask';
import { withStyles, createStyles } from '@material-ui/core';
import { TextField } from '../index';
import { DateUtils } from '../utils';
var FormatConfig = {
    date: {
        format: 'DD/MM/YYYY',
        mask: [/\d/, /\d/, '/', /\d/, /\d/, '/', /\d/, /\d/, /\d/, /\d/],
    },
    day: {
        format: 'DD/MM',
        mask: [/\d/, /\d/, '/', /\d/, /\d/],
    },
    time: {
        format: 'HH:mm',
        mask: [/\d/, /\d/, ':', /\d/, /\d/],
    },
    datetime: {
        format: 'DD/MM/YYYY HH:mm',
        mask: [
            /\d/,
            /\d/,
            '/',
            /\d/,
            /\d/,
            '/',
            /\d/,
            /\d/,
            /\d/,
            /\d/,
            ' ',
            /\d/,
            /\d/,
            ':',
            /\d/,
            /\d/,
        ],
    },
};
var styles = function (theme) { return createStyles({}); };
var DateTimeTextField = /** @class */ (function (_super) {
    __extends(DateTimeTextField, _super);
    function DateTimeTextField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.CustomMaskedInput = function (props) {
            var _a = _this.props, format = _a.format, showMask = _a.showMask, guide = _a.guide, placeholderChar = _a.placeholderChar, keepCharPositions = _a.keepCharPositions;
            var inputRef = props.inputRef, otherProps = __rest(props, ["inputRef"]);
            return (React.createElement(MaskedInput, __assign({}, otherProps, { ref: function (ref) {
                    inputRef(ref ? ref.inputElement : null);
                }, mask: FormatConfig[format].mask, placeholderChar: placeholderChar, showMask: showMask, guide: guide, keepCharPositions: keepCharPositions })));
        };
        _this.handleOnBlur = function (e) {
            var _a = _this.props, onChange = _a.onChange, format = _a.format;
            if (!onChange) {
                return;
            }
            var value = e.target.value;
            var momentValue = moment.utc(value, FormatConfig[format].format);
            // Invalid date/time
            if (!momentValue.isValid()) {
                onChange(undefined);
                return;
            }
            // Add some fixed values
            switch (format) {
                case 'day': {
                    momentValue.year(1970);
                    break;
                }
                case 'time': {
                    momentValue.date(1);
                    momentValue.month(0);
                    momentValue.year(1970);
                    break;
                }
            }
            // Valid date/time
            if (momentValue.isValid()) {
                onChange(momentValue.valueOf());
            }
        };
        _this.handleOnFocus = function () {
            // Timer is a workaround :)
            setTimeout(function () {
                if (_this.inputRef && _this.inputRef.setSelectionRange) {
                    _this.inputRef.setSelectionRange(0, 0);
                }
            }, 0);
        };
        return _this;
    }
    DateTimeTextField.prototype.render = function () {
        var _this = this;
        var _a = this.props, helperText = _a.helperText, showFormatHelper = _a.showFormatHelper, value = _a.value, format = _a.format, showMask = _a.showMask, placeholderChar = _a.placeholderChar, keepCharPositions = _a.keepCharPositions, onChange = _a.onChange, otherProps = __rest(_a, ["helperText", "showFormatHelper", "value", "format", "showMask", "placeholderChar", "keepCharPositions", "onChange"]);
        return (React.createElement(TextField, __assign({}, otherProps, { value: value !== undefined ? DateUtils.format(value, FormatConfig[format].format) : '', helperText: showFormatHelper ? FormatConfig[format].format : helperText, InputProps: {
                inputComponent: this.CustomMaskedInput,
                onFocus: this.handleOnFocus,
                inputRef: function (ref) { return (_this.inputRef = ref); },
            }, InputLabelProps: { shrink: showMask }, onBlur: this.handleOnBlur })));
    };
    DateTimeTextField.defaultProps = {
        mode: 'input',
        format: 'date',
        placeholderChar: '_',
        keepCharPositions: true,
    };
    return DateTimeTextField;
}(React.Component));
export default withStyles(styles)(DateTimeTextField);
//# sourceMappingURL=DateTimeTextField.js.map