var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import MaterialDialog from '@material-ui/core/Dialog';
import DialogContent from '@material-ui/core/DialogContent';
import DialogActions from '@material-ui/core/DialogActions';
import Typography from '@material-ui/core/Typography';
import DialogTitle from '@material-ui/core/DialogTitle';
import IconButton from '@material-ui/core/IconButton';
import Button from '@material-ui/core/Button';
import AppBar from '@material-ui/core/AppBar';
import Toolbar from '@material-ui/core/Toolbar';
import CloseIcon from '@material-ui/icons/Close';
var styles = function (theme) {
    return createStyles({
        root: {},
        title: {},
        appBarTitle: {
            flex: 1,
        },
        container: {},
        paper: {
            minWidth: 550,
            '@media (max-width: 600px)': {
                minWidth: '95%',
            },
        },
        dialogContent: {
            position: 'relative',
            paddingBottom: 0,
        },
        dialogActions: {},
        withAppBar: {
            paddingTop: theme.spacing(2),
        },
        appBarComponentContainer: {
            paddingLeft: theme.spacing(3),
            paddingRight: theme.spacing(3),
            paddingBottom: theme.spacing(2),
        },
        toolbar: {
            paddingRight: theme.spacing(1),
        },
    });
};
var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleCloseButtonClick = function (event) {
            if (_this.props.onClose) {
                _this.props.onClose(event, 'escapeKeyDown');
            }
        };
        _this.handleButtonClick = function (action) { return function () {
            action.handler();
        }; };
        _this.renderActions = function () {
            var actions = _this.props.actions;
            if (actions && actions.length > 0) {
                return actions.map(function (a) { return (React.createElement(Button, { key: a.text, color: a.color, disabled: a.disabled === true, variant: a.variant, onClick: _this.handleButtonClick(a) }, a.text)); });
            }
            return null;
        };
        return _this;
    }
    Dialog.prototype.render = function () {
        var _a;
        var _b = this.props, title = _b.title, scroll = _b.scroll, withAppBar = _b.withAppBar, appBarComponent = _b.appBarComponent, onClose = _b.onClose, classes = _b.classes, className = _b.className, restProps = __rest(_b, ["title", "scroll", "withAppBar", "appBarComponent", "onClose", "classes", "className"]);
        var titleView = withAppBar ? (React.createElement(AppBar, { position: "static" },
            React.createElement(Toolbar, { className: classes.toolbar },
                React.createElement(Typography, { variant: "h6", color: "inherit", className: classes.appBarTitle }, title),
                onClose && (React.createElement(IconButton, { color: "inherit", onClick: this.handleCloseButtonClick },
                    React.createElement(CloseIcon, null)))),
            appBarComponent && (React.createElement("div", { className: classes.appBarComponentContainer }, appBarComponent)))) : (React.createElement(DialogTitle, { className: classes.title }, title));
        return (React.createElement(MaterialDialog, __assign({}, restProps, { onClose: onClose, classes: { paper: classes.paper, container: classes.container }, className: classNames(classes.root, className) }),
            titleView,
            React.createElement(DialogContent, { className: classNames(classes.dialogContent, (_a = {}, _a[classes.withAppBar] = withAppBar, _a)) }, this.props.children),
            React.createElement(DialogActions, { className: classes.dialogActions }, this.renderActions())));
    };
    Dialog.defaultProps = {
        keepMounted: false,
        fullScreen: false,
        withAppBar: false,
    };
    return Dialog;
}(React.Component));
export default withStyles(styles)(Dialog);
//# sourceMappingURL=Dialog.js.map