var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import * as classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { default as MaterialExpansionPanel } from '@material-ui/core/ExpansionPanel';
import ExpansionPanelSummary from '@material-ui/core/ExpansionPanelSummary';
import Typography from '@material-ui/core/Typography';
import ExpansionPanelDetails from '@material-ui/core/ExpansionPanelDetails';
import ExpansionPanelActions from '@material-ui/core/ExpansionPanelActions';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import Divider from '@material-ui/core/Divider';
import { Button } from '../index';
var styles = function (theme) {
    return createStyles({
        root: {},
        text: {},
        summary: {},
        summaryContent: {},
        summaryContentExpanded: {},
        content: {},
        panel: {},
        expandedPanel: {},
    });
};
var ExpansionPanel = /** @class */ (function (_super) {
    __extends(ExpansionPanel, _super);
    function ExpansionPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOnChange = function (event, expanded) {
            if (_this.props.onChange) {
                _this.props.onChange(event, expanded);
            }
        };
        return _this;
    }
    ExpansionPanel.prototype.render = function () {
        var _a = this.props, classes = _a.classes, className = _a.className, title = _a.title, expanded = _a.expanded, withSummary = _a.withSummary, withIcon = _a.withIcon, actions = _a.actions, PanelSummaryView = _a.PanelSummaryView, TitleProps = _a.TitleProps;
        var panelSummaryView = PanelSummaryView ? (PanelSummaryView) : title ? (React.createElement(Typography, __assign({ className: classes.text }, TitleProps), title)) : null;
        var summaryView = withSummary && (React.createElement(ExpansionPanelSummary, { expandIcon: withIcon && React.createElement(ExpandMoreIcon, null), classes: {
                content: classes.summaryContent,
                expanded: classes.summaryContentExpanded,
            }, className: classes.summary }, panelSummaryView));
        return (React.createElement(MaterialExpansionPanel, { expanded: expanded, onChange: this.handleOnChange, classes: {
                root: classes.panel,
                expanded: classes.expandedPanel,
            }, className: classNames(classes.root, className) },
            summaryView,
            !!this.props.children && (React.createElement(ExpansionPanelDetails, { className: classes.content }, this.props.children)),
            actions && actions.length > 0 && (React.createElement(React.Fragment, null,
                React.createElement(Divider, null),
                React.createElement(ExpansionPanelActions, null, actions.map(function (a) { return (React.createElement(Button, { key: a.text, size: "small", color: a.color, variant: a.variant, onClick: a.handler }, a.text)); }))))));
    };
    ExpansionPanel.defaultProps = {
        withSummary: true,
        withIcon: true,
    };
    return ExpansionPanel;
}(React.Component));
export default withStyles(styles)(ExpansionPanel);
//# sourceMappingURL=ExpansionPanel.js.map