var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { createStyles, withStyles } from '@material-ui/core/styles';
import Snackbar from '@material-ui/core/Snackbar';
import { AlertDialog, Button } from '../index';
import Strings from './FeedbackView.strings';
var styles = function (theme) { return createStyles({}); };
var FeedbackView = /** @class */ (function (_super) {
    __extends(FeedbackView, _super);
    function FeedbackView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FeedbackView.prototype.render = function () {
        var _a = this.props, open = _a.open, variant = _a.variant, autoHideDuration = _a.autoHideDuration, actionText = _a.actionText, children = _a.children, restProps = __rest(_a, ["open", "variant", "autoHideDuration", "actionText", "children"]);
        var action = {
            text: actionText,
            handler: this.props.onClose,
        };
        return (React.createElement(React.Fragment, null,
            React.createElement(Snackbar, __assign({}, restProps, { key: "feedback-view-snackbar", open: open && variant === 'info', action: React.createElement(Button, { color: "primary", size: "small", onClick: action.handler }, action.text), anchorOrigin: {
                    vertical: 'bottom',
                    horizontal: 'right',
                }, autoHideDuration: autoHideDuration })),
            React.createElement(AlertDialog, __assign({}, restProps, { key: "feedback-view-dialog", open: open && variant === 'error', actionText: actionText }))));
    };
    FeedbackView.defaultProps = {
        variant: 'error',
        actionText: Strings.ok,
        autoHideDuration: 3000,
    };
    return FeedbackView;
}(React.Component));
export default withStyles(styles)(FeedbackView);
//# sourceMappingURL=FeedbackView.js.map