var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import * as classNames from 'classnames';
import { withStyles, createStyles } from '@material-ui/core/styles';
import Popover from '@material-ui/core/Popover';
import IconButton from '@material-ui/core/IconButton';
import Typography from '@material-ui/core/Typography';
import { HelpOutline as HelpIcon, Close as CloseIcon } from '@material-ui/icons';
var styles = function (theme) {
    return createStyles({
        root: {
            height: 'unset',
            width: 'unset',
            padding: theme.spacing(1),
        },
        popover: {
            maxWidth: 300,
        },
        topBar: {
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'center',
            justifyContent: 'space-between',
            padding: theme.spacing(1, 1, 1, 2),
            backgroundColor: theme.palette.primary.main,
            boxShadow: '0 2px 4px rgba(0, 0, 0, 0.2)',
        },
        title: {
            color: theme.palette.getContrastText(theme.palette.primary.main),
            marginRight: theme.spacing(2),
        },
        closeButton: {
            height: 'fit-content',
            width: 'unset',
            padding: theme.spacing(1),
            alignSelf: 'flex-start',
        },
        closeIcon: {
            height: 16,
            width: 16,
            color: theme.palette.getContrastText(theme.palette.primary.main),
        },
        main: {
            padding: theme.spacing(2),
        },
        message: {},
    });
};
var Helper = /** @class */ (function (_super) {
    __extends(Helper, _super);
    function Helper(props) {
        var _this = _super.call(this, props) || this;
        _this.handleOnClose = function () {
            _this.setState({
                anchorEl: null,
            });
        };
        _this.handleOnClick = function (e) {
            _this.setState({
                anchorEl: e.currentTarget,
            });
        };
        _this.state = {
            anchorEl: null,
        };
        return _this;
    }
    Helper.prototype.render = function () {
        var _a = this.props, title = _a.title, message = _a.message, color = _a.color, classes = _a.classes, className = _a.className;
        var anchorEl = this.state.anchorEl;
        var open = Boolean(anchorEl);
        return (React.createElement(React.Fragment, null,
            React.createElement(Popover, { key: "helper-popover", open: open, onClose: this.handleOnClose, anchorEl: anchorEl || undefined, anchorOrigin: {
                    vertical: 'top',
                    horizontal: 'right',
                }, transformOrigin: {
                    vertical: 'bottom',
                    horizontal: 'left',
                }, classes: { paper: classes.popover } },
                React.createElement("div", { className: classes.topBar },
                    React.createElement(Typography, { className: classes.title }, title),
                    React.createElement(IconButton, { onClick: this.handleOnClose, className: classes.closeButton },
                        React.createElement(CloseIcon, { className: classes.closeIcon }))),
                React.createElement("div", { className: classes.main },
                    React.createElement(Typography, { dangerouslySetInnerHTML: { __html: message }, className: classes.message }))),
            React.createElement(IconButton, { key: "helper-icon-button", color: color, onClick: this.handleOnClick, className: classNames(classes.root, className) },
                React.createElement(HelpIcon, null))));
    };
    return Helper;
}(React.Component));
export default withStyles(styles)(Helper);
//# sourceMappingURL=Helper.js.map