var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import classNames from 'classnames';
import { withStyles, createStyles } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';
var styles = function (theme) {
    return createStyles({
        root: {},
        row: {
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'center',
            '& $labelTitle': {
                marginRight: theme.spacing(0.5),
            },
        },
        bold: {
            fontWeight: 500,
        },
        labelTitle: {
            textAlign: 'left',
        },
        labelValue: {
            textAlign: 'left',
        },
    });
};
var DEFAULT_LABEL_VALUE = '-';
var LabelField = /** @class */ (function (_super) {
    __extends(LabelField, _super);
    function LabelField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LabelField.prototype.render = function () {
        var _a, _b;
        var _c = this.props, label = _c.label, value = _c.value, variant = _c.variant, withBoldTitle = _c.withBoldTitle, classes = _c.classes, className = _c.className;
        var isRow = variant === 'row';
        return (React.createElement("div", { className: classNames(classes.root, (_a = {}, _a[classes.row] = variant === 'row', _a), className) },
            label && (React.createElement(Typography, { variant: isRow ? 'body1' : 'body2', gutterBottom: !isRow, className: classNames(classes.labelTitle, (_b = {}, _b[classes.bold] = withBoldTitle, _b)) }, isRow ? label + ":" : label)),
            React.createElement(Typography, { variant: "body1", className: classes.labelValue }, value)));
    };
    LabelField.defaultProps = {
        value: DEFAULT_LABEL_VALUE,
        variant: 'column',
        withBoldTitle: false,
    };
    return LabelField;
}(React.Component));
export default withStyles(styles)(LabelField);
//# sourceMappingURL=LabelField.js.map