var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { default as MaterialList } from '@material-ui/core/List';
import Typography from '@material-ui/core/Typography';
import ListItemText from '@material-ui/core/ListItemText';
import ListItem from '@material-ui/core/ListItem';
import Strings from './List.strings';
var styles = function (theme) { return createStyles({}); };
var List = /** @class */ (function (_super) {
    __extends(List, _super);
    function List(props) {
        var _this = _super.call(this, props) || this;
        _this.handleOnItemClick = function (item) { return function () {
            if (_this.props.onItemClick) {
                _this.props.onItemClick(item);
            }
        }; };
        return _this;
    }
    List.prototype.render = function () {
        var _this = this;
        var _a = this.props, items = _a.items, emptyMessage = _a.emptyMessage, onItemClick = _a.onItemClick, className = _a.className, restProps = __rest(_a, ["items", "emptyMessage", "onItemClick", "className"]);
        if (items.length === 0) {
            return React.createElement(Typography, { className: className }, emptyMessage);
        }
        var isClickable = onItemClick !== undefined;
        return (React.createElement(MaterialList, __assign({}, restProps, { className: className }), items.map(function (i) { return (React.createElement(ListItem, { key: i.id, 
            // @ts-ignore
            button: isClickable, onClick: isClickable ? _this.handleOnItemClick(i) : undefined },
            React.createElement(ListItemText, { primary: i.label, secondary: i.secondaryLabel }))); })));
    };
    List.defaultProps = {
        emptyMessage: Strings.noItems,
    };
    return List;
}(React.Component));
export default withStyles(styles)(List);
//# sourceMappingURL=List.js.map