var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import * as classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import CircularProgress from '@material-ui/core/CircularProgress';
import Typography from '@material-ui/core/Typography';
var styles = function (theme) {
    return createStyles({
        root: {
            position: 'fixed',
            top: 0,
            right: 0,
            bottom: 0,
            left: 0,
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            justifyContent: 'center',
            zIndex: 1000001,
            backgroundColor: 'rgba(255, 255, 255, 0.7)',
        },
        progressContainer: {
            display: 'flex',
            flexDirection: 'row',
            alignItems: 'center',
            justifyContent: 'center',
            '& > p': {
                marginLeft: theme.spacing(2),
            },
        },
    });
};
var LoadingView = /** @class */ (function (_super) {
    __extends(LoadingView, _super);
    function LoadingView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOnClick = function (event) {
            event.stopPropagation();
        };
        return _this;
    }
    LoadingView.prototype.render = function () {
        var _a = this.props, visible = _a.visible, progressSize = _a.progressSize, message = _a.message, classes = _a.classes, className = _a.className;
        if (!visible) {
            return null;
        }
        return (React.createElement("div", { onClick: this.handleOnClick, className: classNames(classes.root, className) },
            React.createElement("div", { className: classes.progressContainer },
                React.createElement(CircularProgress, { size: progressSize }),
                message && React.createElement(Typography, { color: "primary" }, message))));
    };
    LoadingView.defaultProps = {
        visible: false,
        progressSize: 36,
    };
    return LoadingView;
}(React.Component));
export default withStyles(styles)(LoadingView);
//# sourceMappingURL=LoadingView.js.map