import * as React from 'react';
import { Theme, WithStyles } from '@material-ui/core/styles';
import { DefaultProps, TextFieldProps, Location, LabelFieldProps } from '../index';
declare type ComponentProps = {
    value?: Location;
    locationError?: {
        address?: {
            street?: boolean;
            streetNumber?: boolean;
            postalCode?: boolean;
        };
        city?: boolean;
        province?: boolean;
        fraction?: boolean;
        state?: boolean;
    };
    locationHelper?: {
        address?: {
            street?: string;
            streetNumber?: string;
            postalCode?: string;
        };
        city?: string;
        province?: string;
        fraction?: string;
        state?: string;
    };
    usePlaceholder?: boolean;
    withCity?: boolean;
    withProvince?: boolean;
    withFraction?: boolean;
    withState?: boolean;
    addressLabel?: string;
    addressFieldName?: string;
    LabelFieldProps?: Pick<LabelFieldProps, 'variant' | 'withBoldTitle'>;
    searchParams?: any;
    onFetchCitySuggestions?(value: any): Promise<any[]>;
    onChange?(value: Location, fields?: string[]): void;
    onClear?(event: React.ChangeEvent<HTMLInputElement>, fields?: string[]): void;
};
export declare type Props = ComponentProps & Pick<TextFieldProps, 'mode' | 'label' | 'error' | 'helperText' | 'className' | 'variant'> & WithStyles<typeof styles>;
declare const styles: (theme: Theme) => Record<"input" | "label" | "root" | "inputContainer" | "addressForm", import("@material-ui/core/styles/withStyles").CSSProperties | import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}> | ((props: {}) => import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}>)>;
declare const _default: React.ComponentType<Pick<Pick<Props, "error" | "label" | "className" | "classes" | "onChange" | "variant" | "LabelFieldProps" | "onClear" | "helperText" | "usePlaceholder" | "locationHelper" | "addressLabel" | "searchParams" | "onFetchCitySuggestions"> & Partial<Pick<Props, "value" | "mode" | "locationError" | "addressFieldName" | "withCity" | "withProvince" | "withFraction" | "withState">> & Partial<Pick<DefaultProps<Props, "value" | "mode" | "locationError" | "addressFieldName" | "withCity" | "withProvince" | "withFraction" | "withState">, never>>, "error" | "label" | "className" | "onChange" | "variant" | "value" | "mode" | "LabelFieldProps" | "onClear" | "helperText" | "usePlaceholder" | "locationError" | "addressFieldName" | "withCity" | "withProvince" | "withFraction" | "withState" | "locationHelper" | "addressLabel" | "searchParams" | "onFetchCitySuggestions"> & import("@material-ui/core/styles").StyledComponentProps<"input" | "label" | "root" | "inputContainer" | "addressForm">>;
export default _default;
