var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { TextField } from '../index';
var styles = function () { return createStyles({}); };
var NumericTextField = /** @class */ (function (_super) {
    __extends(NumericTextField, _super);
    function NumericTextField(props) {
        var _this = _super.call(this, props) || this;
        _this.parseValue = function (str) {
            var _a = _this.props, numericVariant = _a.numericVariant, precision = _a.precision;
            var strValue = str ? str : '';
            var numValue;
            if (numericVariant === 'int') {
                numValue = parseInt(strValue, 10);
            }
            else {
                strValue = strValue.replace(',', '.');
                numValue = parseFloat(strValue);
            }
            if (isNaN(numValue)) {
                return undefined;
            }
            return parseFloat(parseFloat(numValue + '').toFixed(precision));
        };
        _this.handleOnChange = function (event) {
            var _a = _this.props, onChange = _a.onChange, onClear = _a.onClear;
            _this.setState({
                strValue: event.target.value.replace(/[^0-9$.,-]/g, ''),
            }, function () {
                var value = _this.parseValue(_this.state.strValue);
                if (value === undefined && onClear) {
                    onClear(event);
                }
                else if (onChange) {
                    onChange(value);
                }
            });
        };
        _this.handleOnBlur = function () {
            var _a = _this.props, value = _a.value, minValue = _a.minValue, maxValue = _a.maxValue, onChange = _a.onChange;
            if (!onChange || value === undefined || (minValue === undefined && maxValue === undefined)) {
                return;
            }
            if (minValue !== undefined && value < minValue) {
                onChange(minValue);
            }
            else if (maxValue !== undefined && value > maxValue) {
                onChange(maxValue);
            }
        };
        _this.state = {
            strValue: props.value === undefined ? '' : props.value + '',
        };
        return _this;
    }
    NumericTextField.prototype.componentDidUpdate = function (prevProps) {
        if (this.props.value !== prevProps.value) {
            this.setState({
                strValue: this.props.value === undefined ? '' : this.props.value + '',
            });
        }
    };
    NumericTextField.prototype.render = function () {
        var _a = this.props, value = _a.value, numericVariant = _a.numericVariant, precision = _a.precision, minValue = _a.minValue, maxValue = _a.maxValue, classes = _a.classes, restProps = __rest(_a, ["value", "numericVariant", "precision", "minValue", "maxValue", "classes"]);
        return (React.createElement(TextField, __assign({}, restProps, { value: value === undefined ? '' : value, type: "number", onChange: this.handleOnChange, onBlur: this.handleOnBlur })));
    };
    NumericTextField.defaultProps = {
        numericVariant: 'int',
        precision: 0,
    };
    return NumericTextField;
}(React.Component));
export default withStyles(styles)(NumericTextField);
//# sourceMappingURL=NumericTextField.js.map