import * as React from 'react';
import { Theme, WithStyles } from '@material-ui/core/styles';
import { PaymentSource } from '../CreditCardForm';
import { Props as ButtonProps } from '../Button';
export declare type Props = {
    stripeApiKey: string;
    paymentSources: PaymentSource[];
    isInTestMode?: boolean;
    AddCardButtonProps?: Partial<ButtonProps>;
    PayButtonProps?: Partial<ButtonProps>;
    onPaymentSourceAdded?(pS: PaymentSource): void;
    onPaymentSourceDeleted?(pS: PaymentSource): void;
    onChange?(pS?: PaymentSource): void;
    onNewCardFormVisibilityChange?(b: boolean): void;
};
declare type PropsWithStyle = Props & WithStyles<typeof styles>;
declare const styles: (theme: Theme) => Record<"label" | "root" | "radioGroup" | "formControlLabel" | "brand" | "brandIcon" | "expirationDate" | "addPaymentSourceButton" | "cardItemDelete", import("@material-ui/core/styles/withStyles").CSSProperties | import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}> | ((props: {}) => import("@material-ui/core/styles/withStyles").CreateCSSProperties<{}>)>;
declare const _default: React.ComponentType<Pick<PropsWithStyle, "onChange" | "PayButtonProps" | "stripeApiKey" | "paymentSources" | "isInTestMode" | "AddCardButtonProps" | "onPaymentSourceAdded" | "onPaymentSourceDeleted" | "onNewCardFormVisibilityChange"> & import("@material-ui/core/styles").StyledComponentProps<"label" | "root" | "radioGroup" | "formControlLabel" | "brand" | "brandIcon" | "expirationDate" | "addPaymentSourceButton" | "cardItemDelete">>;
export default _default;
