var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import * as classNames from 'classnames';
import { withStyles, createStyles } from '@material-ui/core/styles';
import FormControl from '@material-ui/core/FormControl';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import Radio from '@material-ui/core/Radio';
import { default as MaterialRadioGroup } from '@material-ui/core/RadioGroup';
import FormLabel from '@material-ui/core/FormLabel';
import FormHelperText from '@material-ui/core/FormHelperText';
import { LabelField } from '../index';
var styles = function (theme) {
    return createStyles({
        root: {},
        radioGroup: {},
        helper: {},
        labelTitle: {},
        labelValue: {},
        radioRoot: {},
        radioLabel: {},
        label: {
            marginBottom: '0.35em',
            color: theme.palette.text.primary,
        },
    });
};
var RadioGroup = /** @class */ (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (e) {
            if (_this.props.onChange) {
                _this.props.onChange(e);
            }
        };
        return _this;
    }
    RadioGroup.prototype.render = function () {
        var _a = this.props, label = _a.label, value = _a.value, items = _a.items, mode = _a.mode, helperText = _a.helperText, error = _a.error, disabled = _a.disabled, color = _a.color, LabelFieldProps = _a.LabelFieldProps, classes = _a.classes, className = _a.className, restProps = __rest(_a, ["label", "value", "items", "mode", "helperText", "error", "disabled", "color", "LabelFieldProps", "classes", "className"]);
        if (mode === 'label') {
            var item = (items || []).find(function (i) { return i.id === value; });
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: label, value: item ? item.label : undefined, classes: { labelTitle: classes.labelTitle, labelValue: classes.labelValue }, className: className })));
        }
        return (React.createElement(FormControl, { disabled: disabled, error: error, component: "fieldset", className: classNames(classes.root, className) },
            label && React.createElement(FormLabel, { component: "legend", className: classes.label }, label),
            React.createElement(MaterialRadioGroup, __assign({}, restProps, { value: value, onChange: this.handleChange, className: classes.radioGroup }), (items || []).map(function (item) { return (React.createElement(FormControlLabel, { key: item.id, value: item.id, label: item.label, control: React.createElement(Radio, { color: color }), classes: {
                    root: classes.radioRoot,
                    label: classes.radioLabel,
                } })); })),
            helperText && React.createElement(FormHelperText, { className: classes.helper }, helperText)));
    };
    return RadioGroup;
}(React.Component));
export default withStyles(styles)(RadioGroup);
//# sourceMappingURL=RadioGroup.js.map