var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { default as MaterialSelect } from '@material-ui/core/Select';
import InputLabel from '@material-ui/core/InputLabel';
import FormHelperText from '@material-ui/core/FormHelperText';
import FormControl from '@material-ui/core/FormControl';
import MenuItem from '@material-ui/core/MenuItem';
import { LabelField } from '../index';
import SelectDialog from '../SelectDialog';
var styles = function (theme) {
    return createStyles({
        formControl: {},
        input: {},
        select: {},
        labelTitle: {},
        labelValue: {},
    });
};
var NO_VALUE = 'no_value';
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event, child) {
            if (event.target.value !== NO_VALUE) {
                if (_this.props.onChange) {
                    _this.props.onChange(event, child);
                }
            }
            else if (_this.props.onReset) {
                _this.props.onReset(event, child);
            }
        };
        _this.handleClick = function () {
            if (_this.props.withDialog) {
                _this.setState({ dialogOpen: true });
            }
        };
        _this.handleDialogSelect = function (item) {
            if (_this.props.onChange) {
                _this.props.onChange({
                    target: {
                        id: _this.props.id,
                        name: _this.props.name,
                        value: item.id,
                    },
                }, undefined);
            }
            _this.setState({ dialogOpen: false });
        };
        _this.handleDialogReset = function () {
            if (_this.props.onReset) {
                _this.props.onReset({
                    target: {
                        id: _this.props.id,
                        name: _this.props.name,
                        value: NO_VALUE,
                    },
                }, undefined);
            }
            _this.setState({ dialogOpen: false });
        };
        _this.handleDialogClose = function () {
            _this.setState({ dialogOpen: false });
        };
        _this.state = {
            dialogOpen: false,
        };
        return _this;
    }
    Select.prototype.componentDidMount = function () {
        if (this.inputLabelRef) {
            this.setState({ labelWidth: this.inputLabelRef.offsetWidth });
        }
    };
    Select.prototype.render = function () {
        var _this = this;
        var _a = this.props, variant = _a.variant, items = _a.items, noValue = _a.noValue, value = _a.value, helperText = _a.helperText, placeholder = _a.placeholder, name = _a.name, id = _a.id, mode = _a.mode, fullWidth = _a.fullWidth, LabelFieldProps = _a.LabelFieldProps, onReset = _a.onReset, withDialog = _a.withDialog, className = _a.className, classes = _a.classes, restProps = __rest(_a, ["variant", "items", "noValue", "value", "helperText", "placeholder", "name", "id", "mode", "fullWidth", "LabelFieldProps", "onReset", "withDialog", "className", "classes"]);
        var dialogOpen = this.state.dialogOpen;
        if (mode === 'label') {
            var item = (items || []).find(function (i) { return i.id === value; });
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: placeholder, value: item ? item.label : undefined, classes: { labelTitle: classes.labelTitle, labelValue: classes.labelValue }, className: className })));
        }
        var shrink = !!value || Boolean(noValue);
        return (React.createElement(FormControl, { fullWidth: fullWidth, variant: variant, className: className },
            placeholder && (React.createElement(InputLabel, { ref: function (ref) {
                    _this.inputLabelRef = ref ? ref : null;
                }, shrink: shrink, htmlFor: id }, placeholder)),
            React.createElement(MaterialSelect, __assign({}, restProps, { id: id, name: name, displayEmpty: true, open: withDialog !== undefined ? false : undefined, onChange: this.handleChange, onClick: this.handleClick, labelWidth: this.state.labelWidth, className: classes.select, value: value !== undefined ? value : NO_VALUE }),
                noValue && (React.createElement(MenuItem, { key: "default_item", value: NO_VALUE, disabled: !onReset },
                    React.createElement("em", null, noValue))),
                (items || []).map(function (i) { return (React.createElement(MenuItem, { key: i.id, value: i.id }, i.label)); })),
            helperText && React.createElement(FormHelperText, null, helperText),
            React.createElement(SelectDialog, { title: placeholder || noValue || '', open: dialogOpen, items: items || [], withSearch: true, onSelect: this.handleDialogSelect, onClose: this.handleDialogClose, onReset: this.props.onReset ? this.handleDialogReset : undefined })));
    };
    return Select;
}(React.Component));
export default withStyles(styles)(Select);
//# sourceMappingURL=Select.js.map