var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { withStyles, createStyles } from '@material-ui/core';
import { TextField, Dialog, List, } from '../index';
import Strings from './SelectDialog.strings';
var styles = function (theme) {
    return createStyles({
        root: {},
        list: {
            paddingTop: 0,
        },
        emptyView: {
            paddingTop: 12,
            paddingRight: theme.spacing(3),
            paddingBottom: 12,
            paddingLeft: theme.spacing(3),
            fontSize: 'unset',
        },
        search: {
            color: '#fff',
            '&:hover': {
                '&:before': {
                    borderBottomColor: 'rgba(255, 255, 255, 0.66) !important',
                },
            },
            '&:before': {
                borderBottomColor: 'rgba(255, 255, 255, 0.65)',
            },
            '&:after': {
                borderBottomColor: 'rgba(255, 255, 255, 1)',
            },
        },
    });
};
var SelectDialog = /** @class */ (function (_super) {
    __extends(SelectDialog, _super);
    function SelectDialog(props) {
        var _this = _super.call(this, props) || this;
        _this.getFilteredItems = function () {
            var _a = _this.props, items = _a.items, withSearch = _a.withSearch;
            if (!withSearch) {
                return items;
            }
            var search = _this.state.search;
            var filteredItems = items
                .filter(function (i) {
                var trimmedLabel = i.label.toLowerCase().replace(/\s/g, '');
                var trimmedSearch = search.toLowerCase().replace(/\s/g, '');
                return trimmedLabel.includes(trimmedSearch);
            })
                .sort(function (a, b) { return a.label.localeCompare(b.label); });
            return filteredItems;
        };
        _this.isSmallScreen = function () {
            return window.innerWidth <= 600;
        };
        _this.handleSearchChange = function (event) {
            var value = event.target.value;
            _this.setState({
                search: value,
            });
        };
        _this.handleOnCancelClick = function () {
            if (_this.props.onClose) {
                _this.props.onClose({}, 'escapeKeyDown');
            }
        };
        _this.handleOnResetClick = function () {
            if (_this.props.onReset) {
                _this.props.onReset();
            }
        };
        _this.state = {
            search: '',
        };
        return _this;
    }
    SelectDialog.prototype.componentDidUpdate = function (oldProps) {
        if (!oldProps.open && this.props.open) {
            this.setState({
                search: '',
            });
        }
    };
    SelectDialog.prototype.render = function () {
        var _a = this.props, items = _a.items, classes = _a.classes, withSearch = _a.withSearch, onSelect = _a.onSelect, onReset = _a.onReset, restProps = __rest(_a, ["items", "classes", "withSearch", "onSelect", "onReset"]);
        var search = this.state.search;
        var actions = [];
        if (onReset) {
            actions.push({
                text: Strings.reset,
                handler: this.handleOnResetClick,
            });
        }
        actions.push({
            text: Strings.cancel,
            handler: this.handleOnCancelClick,
        });
        return (React.createElement(Dialog, __assign({}, restProps, { actions: actions, withAppBar: true, fullScreen: this.isSmallScreen(), appBarComponent: withSearch ? (React.createElement(TextField, { value: this.state.search, placeholder: Strings.search, onChange: this.handleSearchChange, InputProps: { className: classes.search }, fullWidth: true, autoFocus: true })) : undefined }),
            React.createElement(List, { items: this.getFilteredItems(), emptyMessage: withSearch && search.length > 0
                    ? Strings.formatString(Strings.noFilteredItems, search)
                    : undefined, onItemClick: onSelect })));
    };
    SelectDialog.defaultProps = {
        withSearch: false,
    };
    return SelectDialog;
}(React.Component));
export default withStyles(styles)(SelectDialog);
//# sourceMappingURL=SelectDialog.js.map