var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import { default as MaterialSlider } from '@material-ui/core/Slider';
import Typography from '@material-ui/core/Typography';
import FormHelperText from '@material-ui/core/FormHelperText';
import { LabelField } from '../index';
import Strings from './Slider.strings';
var styles = function (theme) {
    return createStyles({
        root: {
            width: '100%',
            display: 'flex',
            flexDirection: 'column',
        },
        label: {},
        slider: {
            width: '100%',
        },
        helper: {
            marginTop: theme.spacing(4),
        },
        valueLabel: {},
    });
};
var Slider = /** @class */ (function (_super) {
    __extends(Slider, _super);
    function Slider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Slider.prototype.render = function () {
        var _a = this.props, label = _a.label, value = _a.value, mode = _a.mode, error = _a.error, helperText = _a.helperText, LabelFieldProps = _a.LabelFieldProps, className = _a.className, classes = _a.classes, restProps = __rest(_a, ["label", "value", "mode", "error", "helperText", "LabelFieldProps", "className", "classes"]);
        if (mode === 'label') {
            var labelValue = void 0;
            if (value === undefined || typeof value === 'number') {
                labelValue = value;
            }
            else {
                labelValue = Strings.formatString(Strings.value, value[0], value[1]);
            }
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: label, value: labelValue, className: className })));
        }
        return (React.createElement("div", { className: classNames(classes.root, className) },
            label && (React.createElement(Typography, { gutterBottom: true, className: classes.label }, label)),
            React.createElement(MaterialSlider, __assign({}, restProps, { value: value, classes: { valueLabel: classes.valueLabel }, className: classes.slider })),
            helperText && (React.createElement(FormHelperText, { error: error, className: classes.helper }, helperText))));
    };
    Slider.defaultProps = {
        mode: 'input',
    };
    return Slider;
}(React.Component));
export default withStyles(styles)(Slider);
//# sourceMappingURL=Slider.js.map