var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import classNames from 'classnames';
import { createStyles, withStyles } from '@material-ui/core/styles';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import { default as MaterialSwitch } from '@material-ui/core/Switch';
import { LabelField } from '../index';
import Strings from './Switch.strings';
var styles = function (theme) {
    return createStyles({
        root: {
            margin: 0,
        },
        switch: {
            alignSelf: 'flex-start',
        },
        error: {
            color: theme.palette.error.main,
        },
    });
};
var Switch = /** @class */ (function (_super) {
    __extends(Switch, _super);
    function Switch() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Switch.prototype.render = function () {
        var _a;
        var _b = this.props, placeholder = _b.placeholder, checked = _b.checked, error = _b.error, mode = _b.mode, labelPlacement = _b.labelPlacement, LabelFieldProps = _b.LabelFieldProps, className = _b.className, classes = _b.classes, restProps = __rest(_b, ["placeholder", "checked", "error", "mode", "labelPlacement", "LabelFieldProps", "className", "classes"]);
        if (mode === 'label') {
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: placeholder, value: checked ? Strings.checked : Strings.notChecked, className: className })));
        }
        return (React.createElement(FormControlLabel, { checked: checked, control: React.createElement(MaterialSwitch, __assign({}, restProps, { className: classes.switch })), label: placeholder, labelPlacement: labelPlacement, className: classNames(classes.root, className, (_a = {}, _a[classes.error] = error, _a)) }));
    };
    Switch.defaultProps = {
        mode: 'input',
    };
    return Switch;
}(React.Component));
export default withStyles(styles)(Switch);
//# sourceMappingURL=Switch.js.map