var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { withStyles, createStyles } from '@material-ui/core/styles';
import { default as MaterialTextField } from '@material-ui/core/TextField';
import MenuItem from '@material-ui/core/MenuItem';
import { LabelField } from '../index';
var styles = function (theme) {
    return createStyles({
        input: {},
        labelTitle: {},
        labelValue: {},
    });
};
var NoValue = 'NO_VALUE';
var TextField = /** @class */ (function (_super) {
    __extends(TextField, _super);
    function TextField(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (event) {
            var _a = _this.props, onChange = _a.onChange, onClear = _a.onClear;
            var value = event.target.value;
            if (value.length === 0 && onClear) {
                onClear(event);
            }
            else if (onChange) {
                onChange(event);
            }
        };
        return _this;
    }
    TextField.prototype.render = function () {
        var _a = this.props, value = _a.value, label = _a.label, placeholder = _a.placeholder, startAdornment = _a.startAdornment, endAdornment = _a.endAdornment, onClear = _a.onClear, mode = _a.mode, select = _a.select, LabelFieldProps = _a.LabelFieldProps, InputProps = _a.InputProps, items = _a.items, classes = _a.classes, className = _a.className, restProps = __rest(_a, ["value", "label", "placeholder", "startAdornment", "endAdornment", "onClear", "mode", "select", "LabelFieldProps", "InputProps", "items", "classes", "className"]);
        if (mode === 'label') {
            var labelValue = value === undefined || (typeof value === 'string' && value.length === 0)
                ? undefined
                : value;
            if (select && value !== undefined) {
                var item = items.find(function (i) { return i.id === value; });
                labelValue = item ? item.label : undefined;
            }
            var labelTitle = label ? label : placeholder ? placeholder : undefined;
            return (React.createElement(LabelField, __assign({}, LabelFieldProps, { label: labelTitle, value: labelValue, classes: { labelTitle: classes.labelTitle, labelValue: classes.labelValue }, className: className })));
        }
        var val = value;
        if (select && value === undefined) {
            val = NoValue;
        }
        var children = [];
        if (select) {
            children = [
                React.createElement(MenuItem, { key: NoValue, value: NoValue, disabled: !onClear },
                    React.createElement("em", null, placeholder)),
            ];
            items.forEach(function (i) {
                children.push(React.createElement(MenuItem, { key: i.id, value: i.id }, i.label));
            });
        }
        return (
        // @ts-ignore
        React.createElement(MaterialTextField, __assign({}, restProps, { placeholder: placeholder, label: label, value: val, select: select, InputProps: __assign(__assign({}, InputProps), { startAdornment: startAdornment, endAdornment: endAdornment, classes: {
                    input: classes.input,
                } }), onChange: this.handleChange, className: className }), children));
    };
    TextField.defaultProps = {
        mode: 'input',
        variant: 'standard',
        items: [],
    };
    return TextField;
}(React.Component));
export default withStyles(styles)(TextField);
//# sourceMappingURL=TextField.js.map