/// <reference types="react" />
export { default as FiscalCodeTextField, Props as FiscalCodeTextFieldProps, FiscalCodeData, } from './FiscalCodeTextField';
export { default as TextField, Props as TextFieldProps } from './TextField';
export { default as TooltipIcon, Props as TooltipIconProps } from './TooltipIcon';
export { default as Select, Props as SelectProps } from './Select';
export { default as Checkbox, Props as CheckboxProps } from './Checkbox';
export { default as NumericTextField, Props as NumericTextFieldProps } from './NumericTextField';
export { default as Button, Props as ButtonProps } from './Button';
export { default as Dialog, Props as DialogProps } from './Dialog';
export { default as LabelField, Props as LabelFieldProps } from './LabelField';
export { default as DateTimeTextField, Props as DateTimeTextFieldProps } from './DateTimeTextField';
export { default as List, Props as ListProps } from './List';
export { default as SelectDialog, Props as SelectDialogProps } from './SelectDialog';
export { default as AlertDialog, Props as AlertDialogProps } from './AlertDialog';
export { default as FeedbackView, Props as FeedbackViewProps } from './FeedbackView';
export { default as LoadingView, Props as LoadingViewProps } from './LoadingView';
export { default as Helper, Props as HelperProps } from './Helper';
export { default as RadioGroup, Props as RadioGroupProps } from './RadioGroup';
export { default as ConfirmDialog, Props as ConfirmDialogProps } from './ConfirmDialog';
export { default as Counter, Props as CounterProps } from './Counter';
export { default as Switch, Props as SwitchProps } from './Switch';
export { default as Slider, Props as SliderProps } from './Slider';
export { default as Chip, Props as ChipProps } from './Chip';
export { default as ConfirmButton, Props as ConfirmButtonProps } from './ConfirmButton';
export { default as ExpansionPanel, Props as ExpansionPanelProps } from './ExpansionPanel';
export { default as ExpansionCheckbox, Props as ExpansionCheckboxProps } from './ExpansionCheckbox';
export { default as AddressForm, Props as AddressFormProps } from './AddressForm';
export { default as LocationForm, Props as LocationFormProps } from './LocationForm';
export { default as AutocompleteTextField, Props as AutocompleteTextFieldProps, } from './AutocompleteTextField';
export { default as DateTimeTypography, Props as DateTimeTypographyProps, } from './DateTimeTypography';
export { default as PaymentSourcesSelect, Props as PaymentSourcesSelectProps, } from './PaymentSourcesSelect';
export { default as CreditCardForm, Props as CreditCardFormProps } from './CreditCardForm';
export declare type InputFieldMode = 'input' | 'label';
export declare type FeedbackViewVariant = 'info' | 'error';
export interface GenericItem {
    id: string;
    label: string;
    secondaryLabel?: string;
}
export declare type GenericArray = GenericItem[];
export declare type DefaultProps<T, K extends keyof T> = {
    [P in K]-?: T[P];
};
export declare type ButtonAction = {
    handler(): void;
    text?: string;
    icon?: React.ComponentType;
    disabled?: boolean;
    color?: 'primary' | 'secondary' | 'default' | 'inherit';
    variant?: 'text' | 'outlined' | 'contained';
};
export declare type Address = {
    street?: string;
    streetNumber?: string;
    postalCode?: string;
};
export declare type Location = {
    address?: Address;
    city?: City;
    province?: Province;
    state?: State;
    fraction?: string;
};
export declare type City = {
    id?: string;
    name?: string;
};
export declare type Province = {
    id?: string;
    name?: string;
    code?: string;
};
export declare type State = {
    id?: string;
    name?: string;
    code?: string;
};
export declare enum Gender {
    Male = "MALE",
    Female = "FEMALE"
}
