var LocationUtils = /** @class */ (function () {
    function LocationUtils() {
    }
    LocationUtils.addressToString = function (address) {
        if (!address ||
            (address.street === undefined &&
                address.streetNumber === undefined &&
                address.postalCode === undefined)) {
            return undefined;
        }
        var addressStringArray = [];
        if (address.street) {
            addressStringArray.push(address.street);
        }
        if (address.streetNumber) {
            addressStringArray.push(address.streetNumber);
        }
        if (address.postalCode) {
            addressStringArray.push(address.postalCode);
        }
        return addressStringArray.join(', ');
    };
    LocationUtils.locationToString = function (location) {
        if (!location) {
            return undefined;
        }
        var locationStringArray = [];
        var addressString = LocationUtils.addressToString(location.address);
        if (addressString) {
            locationStringArray.push(addressString);
        }
        if (location.city && location.city.name) {
            locationStringArray.push(location.city.name);
        }
        if (location.province && location.province.name) {
            locationStringArray.push(location.province.name);
        }
        if (location.state && location.state.name) {
            locationStringArray.push(location.state.name);
        }
        if (location.fraction) {
            locationStringArray.push(location.fraction);
        }
        if (locationStringArray.length === 0) {
            return undefined;
        }
        return locationStringArray.join(', ');
    };
    return LocationUtils;
}());
export default LocationUtils;
//# sourceMappingURL=Location.utils.js.map